/* charset je charconv handle */
/* tj. drzak ke konvertoru Martina Marese */
/* stara se spravu nazvu kodovani ap.*/

/* Neni upraveno pro rozsirovani poctu znakovych sad pomoci tabgen */


/*#define TEST*/

#include <string.h>
#include "charset.h"
#include "strtools.h"  /* strcmpiw */


void charset_convert_init(struct conv_context *prevod,
		  void *srcbuff,
		  void *srcbuff_end,
		  void *destbuff,
		  void *destbuff_end)
{
  if (prevod == NULL) return;

  conv_init(prevod);
  /* mj init */

  prevod->source     = (unsigned char *) srcbuff;
  prevod->source_end = (unsigned char *) srcbuff_end;
  prevod->dest       = (unsigned char *) destbuff;
  prevod->dest_start = (unsigned char *) destbuff;
  prevod->dest_end   = (unsigned char *) destbuff_end;

  return;
}

int charset_convert(struct conv_context *prevod,
		    int src_code,
		    int dest_code)
{
  charset_convert_init(prevod,
		       (unsigned char*)prevod->source,
		       (unsigned char*)prevod->source_end,
		       prevod->dest,   prevod->dest_end);
  /* aby mohl na stejnem bufferu konvertovat vicekrat */

  conv_set_charset(prevod, src_code, dest_code);

  conv_run(prevod);

  return prevod->state;
}

int charset_convert_string(char *src,
			 char *dest, char *dest_end,
			 int src_code, int dest_code)
{
  struct conv_context prevod;

  char *src_end = (char*)src+strlen(src) +1;
			    /* jednicka za koncovou nulu stringu */

  charset_convert_init(&prevod,
		       (unsigned char*)src,
		       (unsigned char*)src_end,
		       (unsigned char*)dest,
		       (unsigned char*)dest_end);

  return charset_convert(&prevod, src_code, dest_code);

}


typedef struct _charset_desc_t {
	// struktura znakov sady v Unicode
	int		id;				// uniktn ID jedno z charset
	char	*namev[4];		// nzvy znakov sady

}	charset_desc_t;

static
charset_desc_t charset_desc[]=
  {
    { CH_UTF8,  { "utf-8",        "unicode",  "u",     0 } },
    { CH_ASC,   { "us-ascii",     "ascii",    "a",     0 } },
    { CH_ISO1,  { "iso-8859-1",   "iso1",     "i1",    0 } },
    { CH_ISO2,  { "iso-8859-2",   "iso2",     "i2",    0 } },
    { CH_1250,  { "windows-1250", "win",      "w",     0 } },
    { CH_KAM,   { "kam-cs",       "kam",      "k",     0 } },
    { CH_KOI8,  { "koi8-cs",      "koi",      "o",     0 } },
    { CH_852,   { "cp-852",       "pcl",      "p",     0 } },
    { CH_CE,    { "apple-ce",     "mac",      "m",     "x-mac-ce" } },
    { 0,        0  },

  };

int
a_to_charset(char* a_name)
{
  charset_desc_t *node;
  char **namep;

  for (node=charset_desc; *(node->namev); node++)
   {
    for (namep=node->namev; *namep; namep++)
     {
      if ( strcmpiw(*namep,a_name) == 0)
	return node->id;
     }
   }

  return CH_UNKNOWN;
}

const char *
charset_to_a(int charset, charset_name_t name_type)
{
  charset_desc_t *node;

  if (charset==CH_UNKNOWN) return NULL;

  for (node=charset_desc; *(node->namev); node++)
    if (node->id == charset)
      return node->namev[name_type];

  return NULL;
}


#ifdef TEST

void main()
{
  char *a="iso2";

  int ch=a_to_charset(a);
}

#endif /*TEST*/


