/* config.h
   Spolecne funkce a data pro spravu konfigurace

   sharable by yaaho, searcher, plotter
*/

#ifndef __CONFIG_H__
#define __CONFIG_H__

typedef int cid;
/* config id */

/* config types */
enum _CONFIG_TYPES
{
  C_END = 0,     /* zarazka */
  C_INT=1,       /* integer */
  C_BOOL,        /* 1 nebo 0 */
  C_STRING,      /* retezec */
  C_CHARSET,     /* retezec interpretovany jako charset */
  C_INCLUDE      /* retezec, ale pres vice radku */
};

/* config exported values */
#define C_KEEP   0
#define C_PASS   1

/* config ids */
enum CIDS
{
  C_NO_CID = 0,
  C_CHARSET_SAVED_DEFAULT=1,
  C_CHARSET_META_CAN_OVERRIDE,
  C_CHARSET_NETWORK_OUTPUT,
  C_CHARSET_NETWORK_INPUT,
  C_CHARSET_ADD_TO_CONTENT_TYPE,
  C_7BIT_ASSUME_ASCII,

  C_ROOT_DIR,
  C_DIR_DELIMITER,
  C_ROOT_URL,
  C_YAAHO_CGI_URL,

  C_HTTP_METHOD_POST,

  C_REQUEST_OFFSET,
  C_REQUEST_COUNT_LIMIT,

  C_LAYOUT_ERROR_PAGE,
  C_LAYOUT_ANSWER_PAGE_HEADER,
  C_LAYOUT_ANSWER_PAGE_ITEM,
  C_LAYOUT_ANSWER_PAGE_FOOTER,

  C_PLOTTER_PATHNAME,
  C_SEARCHER_PATHNAME,
  C_FIND_COMMAND
};

typedef
struct _config_info
{
  int config_type;
  cid config_id;
  int config_exported;
} config_info;

/*

static config_info complete_config_info [] =
{
  {  C_CHARSET,      C_CHARSET_SAVED_DEFAULT,        C_PASS },
  {  C_BOOL,         C_CHARSET_META_CAN_OVERRIDE,    C_PASS },
  {  C_CHARSET,      C_CHARSET_NETWORK_OUTPUT,       C_PASS },
  {  C_CHARSET,      C_CHARSET_NETWORK_INPUT,        C_PASS },
  {  C_BOOL,         C_CHARSET_ADD_TO_CONTENT_TYPE,  C_PASS },
  {  C_BOOL,         C_7BIT_ASSUME_ASCII,            C_PASS },

  {  C_STRING,       C_ROOT_DIR,                     C_PASS },
  {  C_STRING,       C_DIR_DELIMITER,                C_PASS },
  {  C_STRING,       C_ROOT_URL,                     C_PASS },
  {  C_STRING,       C_YAAHO_CGI_URL,                C_PASS },

  {  C_BOOL,         C_HTTP_METHOD_POST,             C_PASS },

  {  C_INT,          C_REQUEST_OFFSET,               C_PASS },
  {  C_INT,          C_REQUEST_COUNT_LIMIT,          C_PASS },

  {  C_INCLUDE,      C_LAYOUT_ERROR_PAGE,            C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_HEADER,    C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_ITEM,      C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_FOOTER,    C_KEEP },

  {  C_STRING,       C_PLOTTER_PATHNAME,             C_PASS },
  {  C_STRING,       C_SEARCHER_PATHNAME,            C_PASS },
  {  C_STRING,       C_FIND_COMMAND,                 C_PASS },

  {  C_END,          C_NO_CID,                       C_PASS }
};


*/


typedef
union { void* ptr; int i; char* str;} config_data;

typedef
struct _config_storage
{
  config_info *info; /* je to vlastne info[], ale BC to pak nebere */
  config_data *data;
} config_storage;

extern config_storage config_store;
/* globalni sklad konfigurace */

int
init_config(config_info *info);
/* inicializuje globalni sklad konfigurace, vraci 0 nebo chybu */

cid
config_name_to_cid(char *name);

int
cid_to_index(cid c);
/* prevede cid na index v globalnim skladu config_store, -1 pokud neni */

#define config_int(CID)           ( config_store.data[ cid_to_index(CID) ].i )
#define config_str(CID)           ( config_store.data[ cid_to_index(CID) ].str )

void
set_config_int(cid CID, int DATA);

void
set_config_str(cid CID, char *DATA);



#include <stdio.h>

int
read_config(FILE *input);
/* nacist konfiguraci z daneho proudu, zastavit se ale po CONFIG_FINISHED */

int
read_config_from_file(char *fname);
/* nacist konfiguraci, vraci pripadnou chybu */

int
read_config_from_file_and_stdin(char *fname);
/* nacist konfiguraci, vraci pripadnou chybu */

void
flush_config(FILE *output);
/* vyplivnout exportovane cleny konfigurace, pak CONFIG_FINISHED */



#endif /*__CONFIG_H__*/

