/* volby kompilace */

//define HTTP_DEBUG
/* vyplivni Content-type: text/plain hned na zacatku */

//define dbgprt
/* ladici vypisy o prubehu spousteni soucasti baliku */

//define searprt
/* ladici vypisy o prubehu hledani */

#define PIPED
/* zapnete, pokud se chcete pokusit udelat automaticke spousteni jednotlivych
   soucasti baliku yaaho */


/*
   cross-yaaho-common
*/
#ifndef __CROSS_H__
#define __CROSS_H__

#ifndef NULL
#define NULL 0
#endif
#define nl	'\n'
typedef char letter;
typedef letter *string;

/* --- nastaveni interniho komunikacniho kanalu a sprava chyb --- */

#define INTCOM_LINE_LEN 512
/* omezeni delky radku pri komunikaci mezi castmi yaaho, omezuje i
   delku cesty, delku vzorku, delku konfiguracni radky
*/
extern int intcom_item_order[];
enum I_COMMANDS
{
  I_NONE      = 0,
  I_PATHNAME  = 5,
  I_STAT,
  I_CHARSET,
  I_RESULTS,
  I_TITLE,
  I_DESCRIPTION,
  I_CONTEXT,
  I_DONE
};

/* oddelovace casti dat v internim streamu mezi castmi yaaho */
/* FIXME potrebuje divocejsi oddelovace, aby se to nechytlo kde ceho */
#define FATAL_FORMAT "FATAL:::"
/* nesmi obsahovat zadne %, protoze by se z toho zblaznil sscanf */
#define CONFIG_FINISHED  "CONFIG_FINISHED"
#define SAMPLES_FINISHED "SAMPLES_FINISHED"
#define FILE_FINISHED "FILE_FINISHED"
#define ALL_FILES_FINISHED "ALL_FILES_FINISHED"

typedef enum
{ not_linked,
  nothing_written,
  config_written,
  samples_written,
  files_written
} prefatal_state_t;
  
extern prefatal_state_t prefatal_state; 

#include <stdio.h>

int fatal_flush(FILE *output, int err);
/* v pripade fatalniho selhani do intkomu vyplive chybejici ukoncovace a pak hlasku chyby,
   vraci true, pokud prefatal_state byl not_linked, takze by mel kolaps hlasit samotny program
   a ne az plotter */

void
check_input_for_fatal(FILE *input);

/* error codes */
/* NEMENIT PORADI CHYB, JE NA NEJ VAZANO POLE POPISKU V cross.c!!! */
enum FATAL_ERROR_CODES
{
  NO_ERROR,
  /* fatal */
  OUT_OF_MEMORY,
  CANT_READ_CONFIG,
  /* errs while reading config from file/stdin ... fatal */
  MISCONF_UNKNOWN_CONFIG_NAME,
  MISCONF_UNSUPPORTED_CONFIG_NAME,
  MISCONF_INTEGER_EXPECTED,
  MISCONF_BOOLEAN_EXPECTED,
  MISCONF_UNKNOWN_CHARSET,
  MISCONF_INCLUDE_STOP_UNSPECIFIED,
  MISCONF_UNEXPECTED_END_OF_FILE,
  MISCONF_EXTERNAL_INCLUDES_UNSUPPORTED,
  MISCONF_INTERNAL_ERROR,
  
  /* when yaaho examines query */
  QUERY_NOT_FOUND,
  NO_SAMPLES_SPECIFIED,
  
  /* when plotter reads items */
  DAMAGED_INTCOM_STREAM,
  INTCOM_STREAM_UNEXPECTED_EOF,
  
  /**/
  OPEN_FAILED,
  GET_INFO_FAILED,
  IO_ERROR,
  
  SEARCHER_EXEC_FAILED,
  FIND_EXEC_FAILED,
  PLOTTER_EXEC_FAILED
};

extern char *_error_string[];
#define error_string(ERRN)  ( _error_string[(ERRN)] )
/* prevede error na string */



/* ---  porovnavaci funkce --- */

#include "charset.h"
#define INTERNAL_CHARSET	CH_ISO2
/* nelze jen tak zmenit, je nutne upravit v cross.c tabulku ztraty citlivosti
   na diakritiku */
int ltr_cmp(letter a, letter b);
int ltr_cmpi(letter a, letter b);



/* --- obecne --- */

void help_and_quit();
/* zobecneny helpator, kazda cast si musi realizovat vlastni */
char *
get_config_file_name(int argc, char *argv[]);
/* zpracuje optiony a vycucne z nich jmeno konfig. souboru,
   nebo vrati NULL*/
void fatal(int errn);
/* zobecneny chytac chyb, kazda cast baliku si musi realizovat vlastni */

#endif /* __CROSS_H__ */
