/* field.h
   prace s dynamicky alokovanymi poli
*/

typedef struct _field
{
  int items_count;
  int items_allocated;
  int allocation_block;
  void **items; /* je to vlastne *items[], ale BC to nebere */
} field;

field *
fld_new(int allocation_block);

int
fld_add_item(field *f, void *itm);
/* vraci idx nove polozky pole nebo -1 */

void *
fld_item(field *f, int idx);
/* vraci polozku idx nebo NULL, kdyz je idx mimo rozsah */

void
fld_set_item(field *f, int idx, void *itm);

#define fld_items_count(FLD)   ( (FLD)->items_count )

void fld_internal_quicksort(field *f, int (*comparator)(void*, void*),
                            int a, int b);

#define fld_quicksort(FLD,COMPARATOR) \
    fld_internal_quicksort( (FLD), (COMPARATOR), 0, fld_items_count(FLD)-1 )

