/*
  plotter.c
  cast yaaho, ktera se stara o vystup nalezenych souboru v peknem html
  havu
*/

#include "cross.h"
#include "config.h"
#include "samples.h"
#include "items.h"

#include "strtools.h" /*myfgetsdebug*/
#ifdef myfgetsdebug
char *myfgets_id="plotter";
#endif

#define DEFAULT_CONFIG_FILE "plotter.conf"

/* globalni promenne */
static int warn_not_all_files=0;
  /* varovani, ze se nepodarilo vyplivnout vsechny nalezene soubory */

static config_info plotter_config_info [] =
{
//  {  C_CHARSET,      C_CHARSET_SAVED_DEFAULT,        C_PASS },
//  {  C_BOOL,         C_CHARSET_META_CAN_OVERRIDE,    C_PASS },
  {  C_CHARSET,      C_CHARSET_NETWORK_OUTPUT,       C_PASS },
//  {  C_CHARSET,      C_CHARSET_NETWORK_INPUT,        C_PASS },
  {  C_BOOL,         C_CHARSET_ADD_TO_CONTENT_TYPE,  C_PASS },
  {  C_STRING,       C_ROOT_DIR,                     C_PASS },
  {  C_STRING,       C_DIR_DELIMITER,                C_PASS },
  {  C_STRING,       C_ROOT_URL,                     C_PASS },
  {  C_STRING,       C_YAAHO_CGI_URL,                C_PASS },
//  {  C_BOOL,         C_HTTP_METHOD_POST,             C_PASS },
  {  C_INT,          C_REQUEST_OFFSET,               C_PASS },
  {  C_INT,          C_REQUEST_COUNT_LIMIT,          C_PASS },
  {  C_INCLUDE,      C_LAYOUT_ERROR_PAGE,            C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_HEADER,    C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_ITEM,      C_KEEP },
  {  C_INCLUDE,      C_LAYOUT_ANSWER_PAGE_FOOTER,    C_KEEP },
//  {  C_STRING,       C_PLOTTER_PATHNAME,             C_PASS },
//  {  C_STRING,       C_SEARCHER_PATHNAME,            C_PASS },
//  {  C_STRING,       C_FIND_COMMAND,                 C_PASS },
  {  C_END,          C_NO_CID,                       C_PASS }
};

#include <stdlib.h> /*exit*/
void help_and_quit()
{
  printf("plotter, part of yaaho\nobo@cuni.cz\n\n");
  exit(0);
}
#include <string.h> /*strcmp*/
static int global_errno;
/* pouziva error substitutor */
int
error_substitutor(FILE *output,char *str)
{
  if (0 == strcmp(str, "ERR_STR"))
    fputs(error_string(global_errno),output);
  else
  if (0 == strcmp(str, "ERR_NO"))
    fprintf(output,"%d",global_errno);
  else
    return 0;
  return 1;
}
void fatal(int err)
{
  char *buffer;
  
  buffer = config_str(C_LAYOUT_ERROR_PAGE);
  if (buffer == NULL)
   {
    /* absolutni selhani, ani preference nenacteny */
    printf(
      "Content-type: text/html"                            "\n"
      ""                                                   "\n"
      "<HTML><HEAD><TITLE>yaaho neuspelo</TITLE></HEAD>"   "\n"
      "<BODY><H1>yaaho: zasadni chyba</H1>"                "\n"
      "%d: %s"                                             "\n"
      "<HR>Kontaktuje prosim webmastera.</BODY></HTML>"    "\n",
      err,error_string(err)
     );
    exit(0); /*FIXME podle toho, co se ceka od skriptu */
   }
  set_config_str(C_LAYOUT_ERROR_PAGE, NULL);
  /* aby priste sel do kyticek */
  flush_http_header(stdout);
  global_errno=err;
  flush_buffer(stdout,buffer, error_substitutor);
  /* dispose(buffer); */
  exit(0);
}
/* --- nacteni vzorku do pameti */
#include "strtools.h"
void read_samples(FILE *input)
/* ze STDIN nacte vsechny vzorky do internich struktur
   na vstupu se ocekava kazda radka samostatny vzorek
   zarazi se na SAMPLES_FINISHED
*/
{
  char line[MAX_SAMPLE_LEN]; //nactena radka
  char *sample, *x_sample;
  char buff2[MAX_SAMPLE_LEN];
  int required; /* je vzorek nutny? */
  /* na stdin se ocekava prisun vzorku v internim kodovani */
  while (my_fgets(line,MAX_SAMPLE_LEN,input))
   {
    if (0 == strcmp(line,SAMPLES_FINISHED))
      return;
      /* konec seznamu vzorku */
    if (*line=='+')
     {
      required=1;
      sample=line+1;
     }
    else
     {
      required=0;
      sample=line;
     }
    
    if(INTERNAL_CHARSET != config_int(C_CHARSET_NETWORK_OUTPUT))
     {
      charset_convert_string(sample, buff2, buff2+MAX_SAMPLE_LEN,
        INTERNAL_CHARSET, config_int(C_CHARSET_NETWORK_OUTPUT));
      x_sample = buff2;
     }
    else
     x_sample = sample;    
    remember_sample(x_sample,required);
    /* zapamatuj si zneni vzorku */
   };
};


int
translate_config_buffers()
{
  config_info *inf;
  char *buff, *newbuff;
  
  if (config_int(C_CHARSET_NETWORK_OUTPUT) == CH_UNKNOWN)
    /* neni, do ceho bychom meli prekladat, jedeme do ASCII */
    set_config_int(C_CHARSET_NETWORK_OUTPUT, CH_ASC);
  
  for(inf=plotter_config_info;
      inf->config_type != C_END;
      inf++)
   if (inf->config_type == C_INCLUDE)
    {
     buff = config_str(inf->config_id);

     newbuff=(char*)malloc(sizeof(char) 
              * (strlen(buff) +1));

     if (! newbuff)
       return OUT_OF_MEMORY;
     charset_convert_string(buff, newbuff, newbuff + strlen(buff),
                      INTERNAL_CHARSET, config_int(C_CHARSET_NETWORK_OUTPUT));
     free(buff);

     set_config_str(inf->config_id,newbuff);
    }
}


int main(int argc, char *argv[])
{
  char *fname;
  int err;
  FILE *input;
  input = stdin;

#ifdef dbgprt
fprintf(stderr, "Plotter on.\n");
#endif

  init_config(plotter_config_info);
  fname=get_config_file_name(argc, argv);
  if (!fname)
    fname=DEFAULT_CONFIG_FILE;
  err=read_config_from_file/*_and_stdin*/(fname);
  if (err)
    fatal(err);
  err=read_config(input);
  if (err)
    fatal(err);

  if(INTERNAL_CHARSET != config_int(C_CHARSET_NETWORK_OUTPUT))
    translate_config_buffers();
  
  init_samples();
  read_samples(input);
  
#ifdef dbgprt
fprintf(stderr, "Plotter: samples are read.\n");
#endif

  init_items();
  err=read_items(input);
#ifdef dbgprt
fprintf(stderr, "Plotter: items are read.\n");
#endif
  if (err)
   {
    if (err == OUT_OF_MEMORY)
      warn_not_all_files=1;
    else
      fatal(err);
   }
  
#ifdef dbgprt
fprintf(stderr, "Plotter: Checking input for fatal error.\n");
#endif
  check_input_for_fatal(input);
#ifdef dbgprt
fprintf(stderr, "Plotter: Sorting.\n");
#endif
  sort_items();
  flush_items(stdout);
#ifdef dbgprt
fprintf(stderr, "Plotter: Plotting.\n");
#endif
  return 0;
}
