// que.c
// jednoducha obecna fronta

/*#define TEST */

#include "que.h"
#include <stdlib.h> /*malloc*/



void emptyque(que *q)
{
  if (q==NULL) return;
  q->head=NULL;
  q->tail=NULL;
  return;
};

void quepush(que *q, void *it)
{
  queitem *box;

  if (q==NULL) return;

  box=(queitem*)malloc(sizeof(queitem));
  if (box==NULL) return;

  box->data=it;
  box->next=NULL;

  if (q->head == NULL)
   {
    q->head=box;
    q->tail=box;
   }
  else
   {
    q->tail->next=box;
    q->tail=box;
   };

  return;
};

void* quepop(que *q)
{
  void *dat;
  queitem *box;

  if (q==NULL) return NULL;

  box=q->head;
  if (box==NULL) return NULL;

  dat=box->data;
  q->head=box->next;
  if (q->head == NULL) q->tail=NULL;

  free(box);
  return dat;
};



#ifdef TEST

#include <stdio.h>

void main()
{
  que q;

  emptyque(&q);

  int i;
  int *box;

  for (i=0; i<10; i++)
   {
    box=(int*)malloc(sizeof(int));
    *box=i;
    quepush(&q,box);
   }

  while (NULL != (box = (int*)quepop(&q)))
   {
    printf("%d ",*box);
    free(box);
   }

}

#endif /*TEST*/
