/* #define TEST */


#include "samples.h"
#include "field.h"

#include <string.h>
#include <stdlib.h>

typedef struct
 {
  string text;
  int    count;
  int    required;
 } sample_t;

field *samples=NULL;

#define SAMPLE(ID)   ( (sample_t*)fld_item(samples,(ID)) )
#define sample_count ( fld_items_count(samples) )

#define SAMPLESBLOCKSIZE  30

void init_samples()
{
  samples=fld_new(SAMPLESBLOCKSIZE);
  if (samples == NULL)
    fatal(OUT_OF_MEMORY);
  
  return;
}


int remember_sample(string samp,int required)
/* zkopiruj vzorek do internich struktur
   vrati ID, ktere bylo vzorku prideleno
*/
{
  int len;
  int id;
  sample_t *box;

  
  box=(sample_t*)malloc(sizeof(sample_t));
  if (box == NULL)
    fatal(OUT_OF_MEMORY);
  
  len=strlen(samp);
  
  box->text=(string)malloc(len*sizeof(letter)+1);
  if (box->text == NULL)
    fatal(OUT_OF_MEMORY);

  strcpy(box->text,samp);
  box->required=required;

  id=fld_add_item(samples, box);
  // pridej na vzorek odkaz a vrat ID toho vzorku

  return id;
}


string get_sample(int id)
/* vrati odkaz do interni kopie vzorku */
{
  return SAMPLE(id)->text;
}



void reset_samples_counter()
/* vynuluj pocitadlo vzorku */
{
  int i;

  for (i=0; i<sample_count; i++)
    SAMPLE(i)->count=0;

  return;
}

void count_sample(int sampid)
/* zapocitej vyskyt vzorku */
{
  sample_t *s;
  s=SAMPLE(sampid);
  s->count++;
  return;
}


int samples_count()
/* vraci pocet vzorku */
{
  return fld_items_count(samples);
}

int required_samples_present()
/* vraci 1, pokud jsou maji vsechny povinne vzorky nenulove pocitadlo */
{
  sample_t *s;
  int i,sum;

  sum=0;
  for (i=0; i<sample_count; i++)
   {
    s=SAMPLE(i);
    if (s->required  && s->count==0)
      return 0;
    sum+=s->count;
   }

  return (sum != 0); /*pokud se v tom nenaslo vubec nic, taky to nechcem */

}


#include <stdio.h>

void
flush_samples_names_delimited(FILE *output, char delim)
/* vysype prehled vzorku na vystup */
{
  int i;
  int must_quote;
  sample_t *s;

  for (i=0; i<sample_count; i++)
   {
    s=SAMPLE(i);
    must_quote= (NULL != strchr(s->text,delim) );
    fprintf(output,"%s%s%s%s%c",
	    (s->required ? "+" : ""),
	    (must_quote  ? "\"": ""),
	    s->text,
	    (must_quote  ? "\"": ""),
	    delim);
   }

  return;
}

void
flush_samples_counts(FILE *output)
/* vysype pocty vzorku na vystup */
{
  int i;

  for (i=0; i<sample_count-1; i++)
    fprintf(output,"%d ",SAMPLE(i)->count);


  fprintf(output,"%d\n",SAMPLE(sample_count-1)->count);
  return;

}








#ifdef TEST

void fatal(int e) {printf("Fatal %d\n",e);};
void help_and_quit(){};

void main()
{
  char *a="vyorek1";
  char *b="vzorek2";
  char *c="nutny vyorek";

  init_samples();

  remember_sample(a,0);
  remember_sample(b,0);
  remember_sample(c,1);

  printf("Samples:\n%s\n%s\n%s\n\n",get_sample(0),
				    get_sample(1), get_sample(2));

  reset_samples_counter();

  count_sample(0); count_sample(1); count_sample(1);
  count_sample(2);

  flush_samples_names_delimited(stdout,' ');
  printf("\n");
  flush_samples_counts(stdout);

  printf("%d\n",required_samples_present());

}

#endif /*TEST*/
