#include "strtools.h"

#include <string.h>
#include <stdio.h> /* sscanf */

/*   #  define TEST    */


int
iswhite(char c)
{
  return ( strchr(WHITE_SET,c) != NULL );
}

char *
skipwhite(char* c)
// peske bl msto na zatku etzce
{
  return c+strspn(c,WHITE_SET);
}

char *
stepwhite(char *c)
/* preskoci bile misto, ale neuspeje (vrati NULL), pokud tam zadne
  misto nebylo */
{
  if (! iswhite(*c) ) return NULL;

  return skipwhite(c);
}

char *
strstepstr(char *big, char *little)
/* prejde retezec little v retezci big */
{
  while (*little == *big)
   {
    little++;
    big++;
   }
  return ( (*little==0) ? big : NULL );
}

void
strchrrepl(char *str, char src, char dest)
/* nahradi jeden znak druhym */
{
  for (; *str; str++)
    if (*str == src)
      *str = dest;
}

#include <ctype.h> /*toupper*/

#ifndef dos
int
strcmpi(char *a, char *b)
{
  if (!a || !b) return (a==b);
    /* prazdne se nerovnaji, nejsou-li oba */

  while ( *a && *b )
   {
    if ( toupper(*a) == toupper(*b) )
     {
      a++; b++;
     }
    else
      return 1;
   }

  return 0; /* cele se rovnaly */
}

char *
strrev(char *a)
/* obrati retezec */
{
  char *save_a;
  char *b;
  char c;
  
  save_a = a;
  b = a+strlen(a)-1;
  for( ; b-a>0; a++, b--)
   {
    c=*a;
    *a=*b;
    *b=c;
   };
 
  return save_a;
}

#endif

int
strcmpiw(char *a, char *b)
/* porovna a a b ignoruje odlisnosti v bilych miste mezi slovy a na zacatku a konci */
{
  if (!a || !b) return (a==b);
    /* prazdne se nerovnaji, nejsou-li oba */

  a=skipwhite(a);
  b=skipwhite(b);
  while ( *a && *b )
   {
    if ( iswhite(*a) || iswhite (*b) )
     {
      a=stepwhite(a); b=stepwhite(b);
      if ( !a || !b )
	return 1;
     }
    if ( toupper(*a) == toupper(*b) )
     {
      a++; b++;
     }
    else
      return 1;
   }

  a=skipwhite(a);
  b=skipwhite(b);

  return !( *a == *b  /*==0*/ );
}

/*
tohle je tak osklive napsano, ze to radsi nepotrebuju

char *
strstri(char *s1, char *s2)
{
  strupr(s2);
  strupr(s1);
  return strstr(s1,s2);
}
*/

void
untag_str(char *s)
/* vyseka z retezce tagy */
{
  char *p, *q;
  
  for (p=s, q=s;  p && *p;  p++, q++)
   {
    if (*p == '<')
     {
      p=strchr(p,'>');
      q--;
     }
    else
      *q=*p;
   }
  *q=0;
}


void
rtrimwhite(char *s)
/* posune koncovou nulu dopredu, aby retezec nemel na konci zadne bile misto */
{
  char *p;
  for (p=s; *s; s++)
    if (!iswhite(*s))
      p=s;
  p++; /* p bylo posledni nebile v s, za nej chci 0 */
  *p=0;
}

void
quextr(char *pair, char *name, char *value)
// rozbali jeden par name=value\0 do separatnich stringu
// stringy jsou buffery!
// overeno.
{
	char *fp=name; // sem se zacne ukladat rozbalena query

//printf("quextr: [%s] -> ",pair);
	*value=0; // buffer na value je zatim prazdny
	while(*pair)
	{
		switch (*pair)
		{
		case '=': // prechod na value;
			*(fp++) = 0;
			fp=value; //prejdi na novy buffer
			pair++;
			break;
		case '%': // opisny znak
			pair++;
			sscanf(pair,"%2x",fp);
			fp++;
			pair+=2;
			break;
		case '+': // mezera
			*(fp++)=' ';
			pair++;
			break;
		default:
			*(fp++)=*(pair++);
		};
	};
	*fp=0; // pridej ukoncovac do bufferu
//printf("[%s]=[%s]",name, value);
}

char *
my_fgets(char* buff, int buff_len, FILE *stream)
/* nacte radku, ale nenecha na jejim konci \n */
{
  char *b, *n;

#ifdef myfgetsdebug
fprintf(stderr,"Myfgets(%s) reading: ",myfgets_id);
#endif
  b=fgets(buff, buff_len, stream);
  if (!b)
   {
#ifdef myfgetsdebug
fprintf(stderr,"read NULL\n");
#endif
    return NULL;
   }

  n=strchr(b,'\n');
  if (n) *n=0;
#ifdef myfgetsdebug
fprintf(stderr,"read >>>%s<<<\n",b);
#endif

  return b;
}



#ifdef TEST

void main()
{
  
}

#endif /*TEST*/

